package at.ac.uibk.gitsearch.service.dto;

import java.lang.reflect.InvocationTargetException;

import org.junit.Assert;

import at.ac.uibk.gitsearch.service.MailService;
import at.ac.uibk.gitsearch.service.dto.SearchResultDTO.GitProject;
import at.ac.uibk.gitsearch.service.dto.SearchResultsDTO.Person;
import at.ac.uibk.gitsearch.testingUtilities.PropertiesTester;
import nl.jqno.equalsverifier.EqualsVerifier;
import nl.jqno.equalsverifier.Warning;

/**
 * Integration tests for {@link MailService}.
 */
public class VariousDTOTest {

	PropertiesTester propertiesTester = new PropertiesTester();

	@org.junit.jupiter.api.Test
	public void testUserProvidedMetadataDTO() throws IllegalAccessException, InvocationTargetException {
		
		
		propertiesTester.testProperties(UserProvidedMetadataDTO.class);
	}

	@org.junit.jupiter.api.Test
	public void testSearchResultsDTO() throws IllegalAccessException, InvocationTargetException {
		propertiesTester.testProperties(SearchResultsDTO.class);
		propertiesTester.testProperties(SearchResultDTO.class);
		propertiesTester.testProperties(Person.class);
		propertiesTester.testProperties(GitProject.class);
	}
	
	@org.junit.jupiter.api.Test
	public void testSearchInputDTO() throws IllegalAccessException, InvocationTargetException {
		propertiesTester.testProperties(SearchInputDTO.class);
	}
	
	@org.junit.jupiter.api.Test
	public void testVariousEquals() throws IllegalAccessException, InvocationTargetException {
		GitProject p1 = new GitProject(); p1.setProjectId(10);
		GitProject p2 = new GitProject(); p2.setProjectId(10);
		GitProject p3 = new GitProject(); p3.setProjectId(20);

		Assert.assertEquals(p1, p2);
		Assert.assertNotEquals(p1, p3);
		EqualsVerifier.forClass(GitProject.class)
		    .suppress(Warning.NONFINAL_FIELDS)
		    .withIgnoredFields("project_name", "namespace","main_group", "last_activity_at", "url", "sub_group").verify();
		EqualsVerifier.forClass(Person.class).suppress(Warning.NONFINAL_FIELDS).verify();
		EqualsVerifier.forClass(at.ac.uibk.gitsearch.service.dto.SearchResultsDTO.GitProject.class)
		    .suppress(Warning.NONFINAL_FIELDS)
		    .withIgnoredFields("namespace", "visibility", "last_activity_at", "url").verify();
	}

}
